diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/model/val-array.h ns-3.41/src/core/model/val-array.h
--- ns-3.40/src/core/model/val-array.h	2023-09-27 13:30:37.634839000 -0700
+++ ns-3.41/src/core/model/val-array.h	2024-02-09 14:44:07.889790000 -0800
@@ -80,7 +80,7 @@
 {
   public:
     // instruct the compiler to generate the default constructor
-    ValArray<T>() = default;
+    ValArray() = default;
     /**
      * \brief Constructor that creates "numPages" number of 2D arrays that are of
      * dimensions "numRows"x"numCols", and are initialized with all-zero elements.
@@ -89,25 +89,25 @@
      * \param numCols the number of columns
      * \param numPages the number of pages
      */
-    ValArray<T>(size_t numRows, size_t numCols = 1, size_t numPages = 1);
+    ValArray(size_t numRows, size_t numCols = 1, size_t numPages = 1);
     /**
      * \brief Constructor creates a single 1D array of values.size () elements and 1 column,
      * and uses std::valarray<T> values to initialize the elements.
      * \param values std::valarray<T> that will be used to initialize elements of 1D array
      */
-    explicit ValArray<T>(const std::valarray<T>& values);
+    explicit ValArray(const std::valarray<T>& values);
     /**
      * \brief Constructor creates a single 1D array of values.size () elements and 1 column,
      * and moves std::valarray<T> values to initialize the elements.
      * \param values std::valarray<T> that will be moved to initialize elements of 1D array
      */
-    ValArray<T>(std::valarray<T>&& values);
+    ValArray(std::valarray<T>&& values);
     /**
      * \brief Constructor creates a single 1D array of values.size () elements and 1 column,
      * and uses values std::vector<T> to initialize the elements.
      * \param values std::vector<T> that will be used to initialize elements of 1D array
      */
-    explicit ValArray<T>(const std::vector<T>& values);
+    explicit ValArray(const std::vector<T>& values);
     /**
      * \brief Constructor creates a single 2D array of numRows and numCols, and uses
      * std::valarray<T> values to initialize the elements.
@@ -115,7 +115,7 @@
      * \param numCols the number of columns
      * \param values valarray<T> that will be used to initialize elements of 3D array
      */
-    ValArray<T>(size_t numRows, size_t numCols, const std::valarray<T>& values);
+    ValArray(size_t numRows, size_t numCols, const std::valarray<T>& values);
     /**
      * \brief Constructor creates a single 2D array of numRows and numCols, and moves
      * std::valarray<T> values to initialize the elements.
@@ -123,7 +123,7 @@
      * \param numCols the number of columns
      * \param values valarray<T> that will be used to initialize elements of 3D array
      */
-    ValArray<T>(size_t numRows, size_t numCols, std::valarray<T>&& values);
+    ValArray(size_t numRows, size_t numCols, std::valarray<T>&& values);
     /**
      * \brief Constructor creates the 3D array of numRows x numCols x numPages dimensions,
      * and uses std::valarray<T> values to initialize all the 2D arrays, where first
@@ -133,7 +133,7 @@
      * \param numPages the number of pages
      * \param values valarray<T> that will be used to initialize elements of 3D array
      */
-    ValArray<T>(size_t numRows, size_t numCols, size_t numPages, const std::valarray<T>& values);
+    ValArray(size_t numRows, size_t numCols, size_t numPages, const std::valarray<T>& values);
     /**
      * \brief Constructor creates the 3D array of numRows x numCols x numPages dimensions,
      * and moves std::valarray<T> values to initialize all the 2D arrays, where first
@@ -143,19 +143,19 @@
      * \param numPages the number of pages
      * \param values valarray<T> that will be used to initialize elements of 3D array
      */
-    ValArray<T>(size_t numRows, size_t numCols, size_t numPages, std::valarray<T>&& values);
+    ValArray(size_t numRows, size_t numCols, size_t numPages, std::valarray<T>&& values);
     /** instruct the compiler to generate the implicitly declared destructor*/
-    virtual ~ValArray<T>() = default;
+    virtual ~ValArray() = default;
     /** instruct the compiler to generate the implicitly declared copy constructor*/
-    ValArray<T>(const ValArray<T>&) = default;
+    ValArray(const ValArray<T>&) = default;
     /**
      * \brief Copy assignment operator.
      * Instruct the compiler to generate the implicitly declared copy assignment operator.
      * \return a reference to the assigned object
      */
-    ValArray<T>& operator=(const ValArray<T>&) = default;
+    ValArray& operator=(const ValArray<T>&) = default;
     /** instruct the compiler to generate the implicitly declared move constructor*/
-    ValArray<T>(ValArray<T>&&) = default;
+    ValArray(ValArray<T>&&) = default;
     /**
      * \brief Move assignment operator.
      * Instruct the compiler to generate the implicitly declared move assignment operator.
@@ -240,24 +240,24 @@
      * \returns ValArray in which each element has been multiplied by the given
      * scalar value.
      */
-    ValArray<T> operator*(const T& rhs) const;
+    ValArray operator*(const T& rhs) const;
     /**
      * \brief operator+ definition for ValArray<T>.
      * \param rhs The rhs ValArray to be added to this ValArray.
      * \return the ValArray instance that holds the results of the operator+
      */
-    ValArray<T> operator+(const ValArray<T>& rhs) const;
+    ValArray operator+(const ValArray<T>& rhs) const;
     /**
      * \brief binary operator- definition for ValArray<T>.
      * \param rhs The rhs ValArray to be subtracted from this ValArray.
      * \return the ValArray instance that holds the results of the operator-
      */
-    ValArray<T> operator-(const ValArray<T>& rhs) const;
+    ValArray operator-(const ValArray<T>& rhs) const;
     /**
      * \brief unary operator- definition for ValArray<T>.
      * \return the ValArray instance that holds the results of the operator-
      */
-    ValArray<T> operator-() const;
+    ValArray operator-() const;
     /**
      * \brief operator+= definition for ValArray<T>.
      * \param rhs The rhs ValArray to be added to this ValArray.
@@ -379,21 +379,21 @@
 ValArray<T>::GetNumRows() const
 {
     return m_numRows;
-};
+}
 
 template <class T>
 inline size_t
 ValArray<T>::GetNumCols() const
 {
     return m_numCols;
-};
+}
 
 template <class T>
 inline size_t
 ValArray<T>::GetNumPages() const
 {
     return m_numPages;
-};
+}
 
 template <class T>
 inline size_t
@@ -411,7 +411,7 @@
     NS_ASSERT_MSG(pageIndex < m_numPages, "Pages index out of bounds");
     size_t index = (rowIndex + m_numRows * (colIndex + m_numCols * pageIndex));
     return m_values[index];
-};
+}
 
 template <class T>
 inline const T&
@@ -422,7 +422,7 @@
     NS_ASSERT_MSG(pageIndex < m_numPages, "Pages index out of bounds");
     size_t index = (rowIndex + m_numRows * (colIndex + m_numCols * pageIndex));
     return m_values[index];
-};
+}
 
 template <class T>
 inline T&
@@ -430,7 +430,7 @@
 {
     NS_ASSERT_MSG(m_numPages == 1, "Cannot use 2D access operator for 3D ValArray.");
     return (*this)(rowIndex, colIndex, 0);
-};
+}
 
 template <class T>
 inline const T&
@@ -438,7 +438,7 @@
 {
     NS_ASSERT_MSG(m_numPages == 1, "Cannot use 2D access operator for 3D ValArray.");
     return (*this)(rowIndex, colIndex, 0);
-};
+}
 
 template <class T>
 inline T&
@@ -451,7 +451,7 @@
                       (m_numRows == 1 && m_numCols == 1),
                   "Access operator allowed only for 1D ValArray.");
     return m_values[index];
-};
+}
 
 template <class T>
 inline const T&
@@ -464,7 +464,7 @@
                       (m_numRows == 1 && m_numCols == 1),
                   "Access operator allowed only for 1D ValArray.");
     return m_values[index];
-};
+}
 
 template <class T>
 inline ValArray<T>
@@ -523,7 +523,7 @@
 {
     NS_ASSERT_MSG(pageIndex < m_numPages, "Invalid page index.");
     return &(m_values[m_numRows * m_numCols * pageIndex]);
-};
+}
 
 template <class T>
 inline const T*
@@ -531,7 +531,7 @@
 {
     NS_ASSERT_MSG(pageIndex < m_numPages, "Invalid page index.");
     return &(m_values[m_numRows * m_numCols * pageIndex]);
-};
+}
 
 template <class T>
 inline bool
@@ -567,14 +567,14 @@
 ValArray<T>::Elem(size_t row, size_t col, size_t page)
 {
     return (*this)(row, col, page);
-};
+}
 
 template <class T>
 inline const T&
 ValArray<T>::Elem(size_t row, size_t col, size_t page) const
 {
     return (*this)(row, col, page);
-};
+}
 
 /*************************************************
  **  Class ValArray non-inline implementations
@@ -587,7 +587,7 @@
       m_numPages{numPages}
 {
     m_values.resize(m_numRows * m_numCols * m_numPages);
-};
+}
 
 template <class T>
 ValArray<T>::ValArray(const std::valarray<T>& values)
@@ -626,7 +626,7 @@
 {
     NS_ASSERT_MSG(m_numRows * m_numCols == values.size(),
                   "Dimensions and the initialization array size do not match.");
-};
+}
 
 template <class T>
 ValArray<T>::ValArray(size_t numRows, size_t numCols, std::valarray<T>&& values)
@@ -637,7 +637,7 @@
     NS_ASSERT_MSG(m_numRows * m_numCols == values.size(),
                   "Dimensions and the initialization array size do not match.");
     m_values = std::move(values);
-};
+}
 
 template <class T>
 ValArray<T>::ValArray(size_t numRows,
@@ -651,7 +651,7 @@
 {
     NS_ASSERT_MSG(m_numRows * m_numCols * m_numPages == values.size(),
                   "Dimensions and the initialization array size do not match.");
-};
+}
 
 template <class T>
 ValArray<T>::ValArray(size_t numRows, size_t numCols, size_t numPages, std::valarray<T>&& values)
@@ -662,7 +662,7 @@
     NS_ASSERT_MSG(m_numRows * m_numCols * m_numPages == values.size(),
                   "Dimensions and the initialization array size do not match.");
     m_values = std::move(values);
-};
+}
 
 template <class T>
 bool
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/model/version.cache ns-3.41/src/core/model/version.cache
--- ns-3.40/src/core/model/version.cache	2023-09-27 13:31:04.826903800 -0700
+++ ns-3.41/src/core/model/version.cache	2024-02-09 14:46:04.290617700 -0800
@@ -1,10 +1,10 @@
-CLOSEST_TAG = '"ns-3.40"'
-VERSION_COMMIT_HASH = '"g4fdc985b5"'
+CLOSEST_TAG = '"ns-3.41"'
+VERSION_COMMIT_HASH = '"ge5039092b"'
 VERSION_DIRTY_FLAG = '0'
 VERSION_MAJOR = '3'
-VERSION_MINOR = '40'
+VERSION_MINOR = '41'
 VERSION_PATCH = '0'
 VERSION_RELEASE_CANDIDATE = '""'
-VERSION_TAG = '"ns-3.40"'
+VERSION_TAG = '"ns-3.41"'
 VERSION_TAG_DISTANCE = '0'
 VERSION_BUILD_PROFILE = 'default'
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/model/wall-clock-synchronizer.cc ns-3.41/src/core/model/wall-clock-synchronizer.cc
--- ns-3.40/src/core/model/wall-clock-synchronizer.cc	2023-09-27 13:30:37.634839000 -0700
+++ ns-3.41/src/core/model/wall-clock-synchronizer.cc	2024-02-09 14:44:07.889790000 -0800
@@ -128,7 +128,7 @@
     // then subtract the current real time in normalized nanoseconds we just got
     // from the normalized simulation time in nanoseconds that is passed in as
     // the parameter ns.  We return an integer difference, but in reality all of
-    // the mechanisms that cause wall-clock to simuator time drift cause events
+    // the mechanisms that cause wall-clock to simulator time drift cause events
     // to be late.  That means that the wall-clock will be higher than the
     // simulation time and drift will be positive.  I would be astonished to
     // see a negative drift, but the possibility is admitted for other
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/test/attribute-test-suite.cc ns-3.41/src/core/test/attribute-test-suite.cc
--- ns-3.40/src/core/test/attribute-test-suite.cc	2023-09-27 13:30:37.634839000 -0700
+++ ns-3.41/src/core/test/attribute-test-suite.cc	2024-02-09 14:44:07.889790000 -0800
@@ -157,6 +157,14 @@
         TEST_C  //!< Test value C.
     };
 
+    /// Test enumerator.
+    enum class Test_ec
+    {
+        TEST_D, //!< Test value D.
+        TEST_E, //!< Test value E.
+        TEST_F  //!< Test value F.
+    };
+
     /**
      * \brief Get the type ID.
      * \return The object TypeId.
@@ -203,14 +211,35 @@
                 .AddAttribute("TestEnum",
                               "help text",
                               EnumValue(TEST_A),
-                              MakeEnumAccessor(&AttributeObjectTest::m_enum),
+                              MakeEnumAccessor<Test_e>(&AttributeObjectTest::m_enum),
                               MakeEnumChecker(TEST_A, "TestA", TEST_B, "TestB", TEST_C, "TestC"))
                 .AddAttribute("TestEnumSetGet",
                               "help text",
                               EnumValue(TEST_B),
-                              MakeEnumAccessor(&AttributeObjectTest::DoSetEnum,
-                                               &AttributeObjectTest::DoGetEnum),
+                              MakeEnumAccessor<Test_e>(&AttributeObjectTest::DoSetEnum,
+                                                       &AttributeObjectTest::DoGetEnum),
                               MakeEnumChecker(TEST_A, "TestA", TEST_B, "TestB", TEST_C, "TestC"))
+                .AddAttribute("TestEnumClass",
+                              "help text",
+                              EnumValue(Test_ec::TEST_D),
+                              MakeEnumAccessor<Test_ec>(&AttributeObjectTest::m_enumclass),
+                              MakeEnumChecker(Test_ec::TEST_D,
+                                              "TestD",
+                                              Test_ec::TEST_E,
+                                              "TestE",
+                                              Test_ec::TEST_F,
+                                              "TestF"))
+                .AddAttribute("TestEnumClassSetGet",
+                              "help text",
+                              EnumValue(Test_ec::TEST_E),
+                              MakeEnumAccessor<Test_ec>(&AttributeObjectTest::DoSetEnumClass,
+                                                        &AttributeObjectTest::DoGetEnumClass),
+                              MakeEnumChecker(Test_ec::TEST_D,
+                                              "TestD",
+                                              Test_ec::TEST_E,
+                                              "TestE",
+                                              Test_ec::TEST_F,
+                                              "TestF"))
                 .AddAttribute("TestRandom",
                               "help text",
                               StringValue("ns3::ConstantRandomVariable[Constant=1.0]"),
@@ -268,11 +297,12 @@
                               BooleanValue(false),
                               MakeBooleanAccessor(&AttributeObjectTest::m_boolSrc),
                               MakeBooleanChecker())
-                .AddAttribute("EnumTraceSource",
-                              "help text",
-                              EnumValue(TEST_A),
-                              MakeEnumAccessor(&AttributeObjectTest::m_enumSrc),
-                              MakeEnumChecker(TEST_A, "TestA"))
+                .AddAttribute(
+                    "EnumTraceSource",
+                    "help text",
+                    EnumValue(TEST_A),
+                    MakeEnumAccessor<TracedValue<Test_e>>(&AttributeObjectTest::m_enumSrc),
+                    MakeEnumChecker(TEST_A, "TestA"))
                 .AddAttribute("ValueClassSource",
                               "help text",
                               ValueClassTestValue(ValueClassTest()),
@@ -492,6 +522,26 @@
         return m_enumSetGet;
     }
 
+    /**
+     * Set the m_enumClassSetGet value.
+     * \param v The value to set.
+     * \return true.
+     */
+    bool DoSetEnumClass(Test_ec v)
+    {
+        m_enumClassSetGet = v;
+        return true;
+    }
+
+    /**
+     * Get the m_enumClassSetGet value.
+     * \return the value of m_enumSetGet.
+     */
+    Test_ec DoGetEnumClass() const
+    {
+        return m_enumClassSetGet;
+    }
+
     bool m_boolTestA;                        //!< Boolean test A.
     bool m_boolTest;                         //!< Boolean test.
     bool m_boolTestDeprecated;               //!< Boolean test deprecated.
@@ -502,6 +552,8 @@
     float m_float;                           //!< float.
     Test_e m_enum;                           //!< Enum.
     Test_e m_enumSetGet;                     //!< Enum set-get.
+    Test_ec m_enumclass;                     //!< Enum class.
+    Test_ec m_enumClassSetGet;               //!< Enum class set-get.
     Ptr<RandomVariableStream> m_random;      //!< Random number generator.
     std::vector<Ptr<Derived>> m_vector1;     //!< First vector of derived objects.
     std::vector<Ptr<Derived>> m_vector2;     //!< Second vector of derived objects.
@@ -604,10 +656,7 @@
 void
 AttributeTestCase<BooleanValue>::DoRun()
 {
-    Ptr<AttributeObjectTest> p;
-    bool ok;
-
-    p = CreateObject<AttributeObjectTest>();
+    auto p = CreateObject<AttributeObjectTest>();
     NS_TEST_ASSERT_MSG_NE(p, nullptr, "Unable to CreateObject");
 
     //
@@ -618,7 +667,7 @@
     p = CreateObject<AttributeObjectTest>();
     NS_TEST_ASSERT_MSG_NE(p, nullptr, "Unable to CreateObject");
 
-    ok = CheckGetCodePaths(p, "TestBoolName", "true", BooleanValue(true));
+    bool ok = CheckGetCodePaths(p, "TestBoolName", "true", BooleanValue(true));
     NS_TEST_ASSERT_MSG_EQ(ok, true, "Attribute not set properly by default value");
 
     std::string expected("Attribute 'TestDeprecated' is deprecated: DEPRECATED test working.\n");
@@ -705,17 +754,14 @@
 void
 AttributeTestCase<IntegerValue>::DoRun()
 {
-    Ptr<AttributeObjectTest> p;
-    bool ok;
-
-    p = CreateObject<AttributeObjectTest>();
+    auto p = CreateObject<AttributeObjectTest>();
     NS_TEST_ASSERT_MSG_NE(p, nullptr, "Unable to CreateObject");
 
     //
     // When the object is first created, the Attribute should have the default
     // value.
     //
-    ok = CheckGetCodePaths(p, "TestInt16", "-2", IntegerValue(-2));
+    bool ok = CheckGetCodePaths(p, "TestInt16", "-2", IntegerValue(-2));
     NS_TEST_ASSERT_MSG_EQ(ok, true, "Attribute not set properly by default value");
 
     //
@@ -840,17 +886,14 @@
 void
 AttributeTestCase<UintegerValue>::DoRun()
 {
-    Ptr<AttributeObjectTest> p;
-    bool ok;
-
-    p = CreateObject<AttributeObjectTest>();
+    auto p = CreateObject<AttributeObjectTest>();
     NS_TEST_ASSERT_MSG_NE(p, nullptr, "Unable to CreateObject");
 
     //
     // When the object is first created, the Attribute should have the default
     // value.
     //
-    ok = CheckGetCodePaths(p, "TestUint8", "1", UintegerValue(1));
+    bool ok = CheckGetCodePaths(p, "TestUint8", "1", UintegerValue(1));
     NS_TEST_ASSERT_MSG_EQ(ok, true, "Attribute not set properly by default value");
 
     //
@@ -923,17 +966,14 @@
 void
 AttributeTestCase<DoubleValue>::DoRun()
 {
-    Ptr<AttributeObjectTest> p;
-    bool ok;
-
-    p = CreateObject<AttributeObjectTest>();
+    auto p = CreateObject<AttributeObjectTest>();
     NS_TEST_ASSERT_MSG_NE(p, nullptr, "Unable to CreateObject");
 
     //
     // When the object is first created, the Attribute should have the default
     // value.
     //
-    ok = CheckGetCodePaths(p, "TestFloat", "-1.1", DoubleValue(-1.1F));
+    bool ok = CheckGetCodePaths(p, "TestFloat", "-1.1", DoubleValue(-1.1F));
     NS_TEST_ASSERT_MSG_EQ(ok, true, "Attribute not set properly by default value");
 
     //
@@ -950,19 +990,16 @@
 
 template <>
 void
-AttributeTestCase<EnumValue>::DoRun()
+AttributeTestCase<EnumValue<AttributeObjectTest::Test_e>>::DoRun()
 {
-    Ptr<AttributeObjectTest> p;
-    bool ok;
-
-    p = CreateObject<AttributeObjectTest>();
+    auto p = CreateObject<AttributeObjectTest>();
     NS_TEST_ASSERT_MSG_NE(p, nullptr, "Unable to CreateObject");
 
     //
     // When the object is first created, the Attribute should have the default
     // value.
     //
-    ok = CheckGetCodePaths(p, "TestEnum", "TestA", EnumValue(AttributeObjectTest::TEST_A));
+    bool ok = CheckGetCodePaths(p, "TestEnum", "TestA", EnumValue(AttributeObjectTest::TEST_A));
     NS_TEST_ASSERT_MSG_EQ(ok, true, "Attribute not set properly by default value");
 
     //
@@ -1028,12 +1065,106 @@
 
 template <>
 void
-AttributeTestCase<TimeValue>::DoRun()
+AttributeTestCase<EnumValue<AttributeObjectTest::Test_ec>>::DoRun()
 {
-    Ptr<AttributeObjectTest> p;
-    bool ok;
+    auto p = CreateObject<AttributeObjectTest>();
+    NS_TEST_ASSERT_MSG_NE(p, nullptr, "Unable to CreateObject");
 
-    p = CreateObject<AttributeObjectTest>();
+    //
+    // When the object is first created, the Attribute should have the default
+    // value.
+    //
+    bool ok = CheckGetCodePaths(p,
+                                "TestEnumClass",
+                                "TestD",
+                                EnumValue(AttributeObjectTest::Test_ec::TEST_D));
+    NS_TEST_ASSERT_MSG_EQ(ok, true, "Attribute not set properly by default value");
+
+    //
+    // Set the Attribute using the EnumValue type.
+    //
+    ok = p->SetAttributeFailSafe("TestEnumClass", EnumValue(AttributeObjectTest::Test_ec::TEST_F));
+    NS_TEST_ASSERT_MSG_EQ(ok, true, "Could not SetAttributeFailSafe() to TEST_F");
+
+    ok = CheckGetCodePaths(p,
+                           "TestEnumClass",
+                           "TestF",
+                           EnumValue(AttributeObjectTest::Test_ec::TEST_F));
+    NS_TEST_ASSERT_MSG_EQ(ok,
+                          true,
+                          "Attribute not set properly by SetAttributeFailSafe() via EnumValue");
+
+    //
+    // When the object is first created, the Attribute should have the default
+    // value.
+    //
+    ok = CheckGetCodePaths(p,
+                           "TestEnumClassSetGet",
+                           "TestE",
+                           EnumValue(AttributeObjectTest::Test_ec::TEST_E));
+    NS_TEST_ASSERT_MSG_EQ(ok, true, "Attribute not set properly by default value");
+
+    //
+    // Set the Attribute using the EnumValue type.
+    //
+    ok = p->SetAttributeFailSafe("TestEnumClassSetGet",
+                                 EnumValue(AttributeObjectTest::Test_ec::TEST_F));
+    NS_TEST_ASSERT_MSG_EQ(ok, true, "Could not SetAttributeFailSafe() to TEST_F");
+
+    ok = CheckGetCodePaths(p,
+                           "TestEnumClassSetGet",
+                           "TestF",
+                           EnumValue(AttributeObjectTest::Test_ec::TEST_F));
+    NS_TEST_ASSERT_MSG_EQ(ok,
+                          true,
+                          "Attribute not set properly by SetAttributeFailSafe() via EnumValue");
+
+    //
+    // Set the Attribute using the StringValue type.
+    //
+    ok = p->SetAttributeFailSafe("TestEnumClass", StringValue("TestE"));
+    NS_TEST_ASSERT_MSG_EQ(ok, true, "Could not SetAttributeFailSafe() to TEST_E");
+
+    ok = CheckGetCodePaths(p,
+                           "TestEnumClass",
+                           "TestE",
+                           EnumValue(AttributeObjectTest::Test_ec::TEST_E));
+    NS_TEST_ASSERT_MSG_EQ(ok,
+                          true,
+                          "Attribute not set properly by SetAttributeFailSafe() via StringValue");
+
+    //
+    // Try to set the Attribute to a bogus enum using the StringValue type
+    // throws a fatal error.
+    //
+    //  ok = p->SetAttributeFailSafe ("TestEnumClass", StringValue ("TestG"));
+    //  NS_TEST_ASSERT_MSG_EQ (ok, false, "Unexpectedly could SetAttributeFailSafe() to TEST_G"); //
+
+    ok = CheckGetCodePaths(p,
+                           "TestEnumClass",
+                           "TestE",
+                           EnumValue(AttributeObjectTest::Test_ec::TEST_E));
+    NS_TEST_ASSERT_MSG_EQ(ok, true, "Error in SetAttributeFailSafe() but value changes");
+
+    //
+    // Try to set the Attribute to a bogus enum using an integer implicit conversion
+    // and make sure the underlying value doesn't change.
+    //
+    ok = p->SetAttributeFailSafe("TestEnumClass", EnumValue(5));
+    NS_TEST_ASSERT_MSG_EQ(ok, false, "Unexpectedly could SetAttributeFailSafe() to 5");
+
+    ok = CheckGetCodePaths(p,
+                           "TestEnumClass",
+                           "TestE",
+                           EnumValue(AttributeObjectTest::Test_ec::TEST_E));
+    NS_TEST_ASSERT_MSG_EQ(ok, true, "Error in SetAttributeFailSafe() but value changes");
+}
+
+template <>
+void
+AttributeTestCase<TimeValue>::DoRun()
+{
+    auto p = CreateObject<AttributeObjectTest>();
     NS_TEST_ASSERT_MSG_NE(p, nullptr, "Unable to CreateObject");
 
     // The test vectors assume ns resolution
@@ -1042,7 +1173,7 @@
     //
     // Set value
     //
-    ok = p->SetAttributeFailSafe("TestTimeWithBounds", TimeValue(Seconds(5)));
+    bool ok = p->SetAttributeFailSafe("TestTimeWithBounds", TimeValue(Seconds(5)));
     NS_TEST_ASSERT_MSG_EQ(ok, true, "Could not SetAttributeFailSafe() via TimeValue to 5s");
 
     ok = CheckGetCodePaths(p, "TestTimeWithBounds", "+5e+09ns", TimeValue(Seconds(5)));
@@ -1168,17 +1299,14 @@
 void
 RandomVariableStreamAttributeTestCase::DoRun()
 {
-    Ptr<AttributeObjectTest> p;
-    bool ok;
-
-    p = CreateObject<AttributeObjectTest>();
+    auto p = CreateObject<AttributeObjectTest>();
     NS_TEST_ASSERT_MSG_NE(p, nullptr, "Unable to CreateObject");
 
     //
     // Try to set a UniformRandomVariable
     //
-    ok = p->SetAttributeFailSafe("TestRandom",
-                                 StringValue("ns3::UniformRandomVariable[Min=0.|Max=1.]"));
+    bool ok = p->SetAttributeFailSafe("TestRandom",
+                                      StringValue("ns3::UniformRandomVariable[Min=0.|Max=1.]"));
     NS_TEST_ASSERT_MSG_EQ(ok, true, "Could not SetAttributeFailSafe() a UniformRandomVariable");
 
     //
@@ -1221,10 +1349,9 @@
 void
 ObjectVectorAttributeTestCase::DoRun()
 {
-    Ptr<AttributeObjectTest> p;
     ObjectVectorValue vector;
 
-    p = CreateObject<AttributeObjectTest>();
+    auto p = CreateObject<AttributeObjectTest>();
     NS_TEST_ASSERT_MSG_NE(p, nullptr, "Unable to CreateObject");
 
     //
@@ -1306,10 +1433,9 @@
 void
 ObjectMapAttributeTestCase::DoRun()
 {
-    Ptr<AttributeObjectTest> p;
     ObjectMapValue map;
 
-    p = CreateObject<AttributeObjectTest>();
+    auto p = CreateObject<AttributeObjectTest>();
     NS_TEST_ASSERT_MSG_NE(p, nullptr, "Unable to CreateObject");
 
     //
@@ -1423,11 +1549,9 @@
 void
 IntegerTraceSourceAttributeTestCase::DoRun()
 {
-    Ptr<AttributeObjectTest> p;
     IntegerValue iv;
-    bool ok;
 
-    p = CreateObject<AttributeObjectTest>();
+    auto p = CreateObject<AttributeObjectTest>();
     NS_TEST_ASSERT_MSG_NE(p, nullptr, "Unable to CreateObject");
 
     //
@@ -1440,7 +1564,7 @@
     //
     // Set the Attribute to a positive value through an IntegerValue.
     //
-    ok = p->SetAttributeFailSafe("IntegerTraceSource1", IntegerValue(5));
+    bool ok = p->SetAttributeFailSafe("IntegerTraceSource1", IntegerValue(5));
     NS_TEST_ASSERT_MSG_EQ(ok, true, "Could not SetAttributeFailSafe() via IntegerValue to 5");
 
     p->GetAttribute("IntegerTraceSource1", iv);
@@ -1548,10 +1672,7 @@
 void
 IntegerTraceSourceTestCase::DoRun()
 {
-    Ptr<AttributeObjectTest> p;
-    bool ok;
-
-    p = CreateObject<AttributeObjectTest>();
+    auto p = CreateObject<AttributeObjectTest>();
     NS_TEST_ASSERT_MSG_NE(p, nullptr, "Unable to CreateObject");
 
     //
@@ -1560,7 +1681,7 @@
     //
     m_got1 = 1234;
 
-    ok = p->SetAttributeFailSafe("IntegerTraceSource1", IntegerValue(-1));
+    bool ok = p->SetAttributeFailSafe("IntegerTraceSource1", IntegerValue(-1));
     NS_TEST_ASSERT_MSG_EQ(ok, true, "Could not SetAttributeFailSafe() via IntegerValue to -1");
 
     //
@@ -1651,10 +1772,7 @@
 void
 TracedCallbackTestCase::DoRun()
 {
-    Ptr<AttributeObjectTest> p;
-    bool ok;
-
-    p = CreateObject<AttributeObjectTest>();
+    auto p = CreateObject<AttributeObjectTest>();
     NS_TEST_ASSERT_MSG_NE(p, nullptr, "Unable to CreateObject");
 
     //
@@ -1680,8 +1798,9 @@
     // Now, wire the TracedCallback up to a trace sink.  This sink will just set
     // m_got2 to the first argument.
     //
-    ok = p->TraceConnectWithoutContext("Source2",
-                                       MakeCallback(&TracedCallbackTestCase::NotifySource2, this));
+    bool ok =
+        p->TraceConnectWithoutContext("Source2",
+                                      MakeCallback(&TracedCallbackTestCase::NotifySource2, this));
     NS_TEST_ASSERT_MSG_EQ(ok, true, "Could not TraceConnectWithoutContext() to NotifySource2");
 
     //
@@ -1752,10 +1871,7 @@
 void
 PointerAttributeTestCase::DoRun()
 {
-    Ptr<AttributeObjectTest> p;
-    bool ok;
-
-    p = CreateObject<AttributeObjectTest>();
+    auto p = CreateObject<AttributeObjectTest>();
     NS_TEST_ASSERT_MSG_NE(p, nullptr, "Unable to CreateObject");
 
     //
@@ -1776,7 +1892,7 @@
     // to that object.  We can then set the PointerValue Attribute to that Ptr.
     //
     derived = Create<Derived>();
-    ok = p->SetAttributeFailSafe("Pointer", PointerValue(derived));
+    bool ok = p->SetAttributeFailSafe("Pointer", PointerValue(derived));
     NS_TEST_ASSERT_MSG_EQ(ok,
                           true,
                           "Could not SetAttributeFailSafe() a PointerValue of the correct type");
@@ -1910,10 +2026,7 @@
 void
 CallbackValueTestCase::DoRun()
 {
-    Ptr<AttributeObjectTest> p;
-    bool ok;
-
-    p = CreateObject<AttributeObjectTest>();
+    auto p = CreateObject<AttributeObjectTest>();
     NS_TEST_ASSERT_MSG_NE(p, nullptr, "Unable to CreateObject");
 
     //
@@ -1938,7 +2051,7 @@
 
     NS_TEST_ASSERT_MSG_EQ(m_gotCbValue, 1, "Callback unexpectedly fired");
 
-    ok = p->SetAttributeFailSafe("Callback", cbValue);
+    bool ok = p->SetAttributeFailSafe("Callback", cbValue);
     NS_TEST_ASSERT_MSG_EQ(ok, true, "Could not SetAttributeFailSafe() a CallbackValue");
 
     //
@@ -1981,7 +2094,11 @@
                 TestCase::QUICK);
     AddTestCase(new AttributeTestCase<DoubleValue>("Check Attributes of type DoubleValue"),
                 TestCase::QUICK);
-    AddTestCase(new AttributeTestCase<EnumValue>("Check Attributes of type EnumValue"),
+    AddTestCase(new AttributeTestCase<EnumValue<AttributeObjectTest::Test_e>>(
+                    "Check Attributes of type EnumValue"),
+                TestCase::QUICK);
+    AddTestCase(new AttributeTestCase<EnumValue<AttributeObjectTest::Test_ec>>(
+                    "Check Attributes of type EnumValue (wrapping an enum class)"),
                 TestCase::QUICK);
     AddTestCase(new AttributeTestCase<TimeValue>("Check Attributes of type TimeValue"),
                 TestCase::QUICK);
